<!DOCTYPE html>
<html lang="en">

<head>
    <title>Users CRUD</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>
    <!-- vùng header -->
    <div class="container">
        <div class=" text-center mt-3">
            <h3>F12 - Quản trị Users </h3>
        </div>
        <div class=" form-group">
            <button class="btn btn-success" id="btn-new-users"><i class="fa fa-plus"> </i>&nbsp; New User </button>
        </div>
    </div>

    <!-- vùng user data table -->
    <div class="container">
        <table id="user-table" class="table table-bordered table-striped table-hover">
            <thead>
                <tr>
                    <th>Mã người dùng</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
    <!-- Vùng Modal -->
    <!-- Create voucher modal -->
    <div>
        <div id="create-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Creat new user</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-firstname">First name</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-firstname" name="firstname"
                                        placeholder="first name" class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-lastname">Last name</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-lastname" name="lastname" placeholder="LastName"
                                        class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-subject">Subject</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-create-subject" name="subject" placeholder="subject"
                                        class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-create-country">Country</label>
                                </div>
                                <div class="col-sm-8">
                                    <select name="select-create-country" id="select-create-country"
                                        class="form-control">
                                        <option value="VN">Việt Nam</option>
                                        <option value="USA">USA</option>
                                        <option value="AUS">Australia</option>
                                        <option value="CAN">Canada</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-create-customer-type">Customer Type</label>
                                </div>
                                <div class="col-sm-8">
                                    <select name="select-create-customer-type" id="select-create-customer-type"
                                        class="form-control">
                                        <option value="Standard">Standard</option>
                                        <option value="Gold">Gold</option>
                                        <option value="Premium">Premium</option>
                                    </select>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-secondary" id="btn-insert-cancel" data-dismiss="modal">
                            Cancel
                        </button>
                        <button class="btn btn-primary" id="btn-insert-user">
                            Insert user
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- Update user modal -->
    <div>
        <div id="update-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Update user</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-firstname">First name</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-firstname" name="firstname"
                                        placeholder="first name" class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-lastname">Last name</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-lastname" name="lastname"
                                        placeholder="last name" class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-update-subject">Subject</label>
                                </div>
                                <div class="col-sm-8">
                                    <input type="text" id="input-update-subject" name="subject" placeholder="subject"
                                        class="form-control" />
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-update-country">Country</label>
                                </div>
                                <div class="col-sm-8">
                                    <select name="select-update-country" id="select-update-country"
                                        class="form-control">
                                        <option value="VN">Việt Nam</option>
                                        <option value="USA">USA</option>
                                        <option value="AUS">Australia</option>
                                        <option value="CAN">Canada</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-update-customer-type">Customer Type</label>
                                </div>
                                <div class="col-sm-8">
                                    <select name="select-update-customer-type" id="select-update-customer-type"
                                        class="form-control">
                                        <option value="Standard">Standard</option>
                                        <option value="Gold">Gold</option>
                                        <option value="Premium">Premium</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="select-update-register-status">Register Status</label>
                                </div>
                                <div class="col-sm-8">
                                    <select name="select-update-register-status" id="select-update-register-status"
                                        class="form-control">
                                        <option value="New">New</option>
                                        <option value="Accepted">Accepted</option>
                                        <option value="Denied">Denied</option>
                                    </select>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-primary" id="btn-update-user">
                            Update user
                        </button>
                        <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">
                            Cancel
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- Confirm user modal -->
    <div>
        <div id="delete-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Confỉrm xóa user</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="row form-group">
                        <div class="col-sm-12">
                            <p>Bạn có chắc chắn muốn xóa user này không?</p>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-primary" id="btn-delete-user">
                            Xác nhận
                        </button>
                        <button class="btn btn-secondary" id="btn-delete-cancel" data-dismiss="modal">
                            Cancel
                        </button>
                    </div>
                </div>
            </div>
        </div>
    </div>

</body>

</body>
<script>
    "use strict"
    const gBAGE_URL = "http://203.171.20.210:8080/crud-api/users/";
    // biến toàn cục để lưu trữ id user
    var gUserID = 0;

    const gUSER_COL = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];

    const gID_COL = 0;
    const gFIRST_NAME_COL = 1;
    const gLAST_NAME_COL = 2;
    const gCOUNTRY_COL = 3;
    const gSUBJECT_COL = 4;
    const gCUSTOMER_TYPE_COL = 5;
    const gREGISTEER_STATUS_COL = 6;
    const gACTION_COL = 7;

    var gUserTable = $("#user-table").DataTable({
        columns: [
            { data: gUSER_COL[gID_COL] },
            { data: gUSER_COL[gFIRST_NAME_COL] },
            { data: gUSER_COL[gLAST_NAME_COL] },
            { data: gUSER_COL[gCOUNTRY_COL] },
            { data: gUSER_COL[gSUBJECT_COL] },
            { data: gUSER_COL[gCUSTOMER_TYPE_COL] },
            { data: gUSER_COL[gREGISTEER_STATUS_COL] },
            { data: gUSER_COL[gACTION_COL] },
        ],
        columnDefs: [
            {
                targets: gACTION_COL,
                defaultContent:
                    ` 
                    <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
                    <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
                    `
            }
        ]

    })
    onPageLoading();

    // gán sự kiện add mới user
    $("#btn-new-users").on("click", function () {
        onBtnAddUser();
    })

    // gán sựu kiên edit -Sửa
    $("#user-table").on("click", ".edit-user", function () {
        onBtnEditUserClick(this);
    })
    // gán sựu kiên delete - Xóa
    $("#user-table").on("click", ".delete-user", function () {
        onBtnDeleteUserClick(this);
    })
    // hàm create user
    $("#btn-insert-user").on("click", function () {
        onBtnCreateUserClick();
    })
    // khi nút update user được ấn
    $("#btn-update-user").on("click", function () {
        onBtnUpdateUser()
    })
    // khi nút xác nhận xóa user được ấn
    $("#btn-delete-user").on("click", function () {
        onBtnConfirmUser();
    })

    function onPageLoading() {
        getAllData();
    }
    // hàm xử lý sự kiêm create user modal click
    function onBtnCreateUserClick() {
        var vObjectRequestData = {
            firstname: "",
            lastname: "",
            subject: "",
            country: "",
            customerType: "",

        }
        getData(vObjectRequestData);
        var Ischeck = validate(vObjectRequestData);
        if (Ischeck) {
            $.ajax({
                url: gBAGE_URL,
                type: "POST",
                contentType: "application/json;charset=UTF-8",
                data: JSON.stringify(vObjectRequestData),
                success: function (pagramRes) {
                    console.log(pagramRes)
                    handInsertUser()
                },
                error: function (pagram) {
                    alert(pagram.status)
                }

            })

        }
        // modal crert được ẩn


    }
    // hàm xử lý sự kiện update user click
    function onBtnUpdateUser() {
        var vUpdateUser = {
            //khai báo 
            firstname: "",
            lastname: "",
            subject: "",
            country: "",
            customerType: "",
            registerStatus: "",
        }
        // thu thập dữ liệu
        readDataFromUpdateModal(vUpdateUser)
        // validate
        var Ischeck = validate(vUpdateUser);
        if (Ischeck) {
            $.ajax({
                url: gBAGE_URL + gUserID,
                type: "PUT",
                contentType: "application/json;charset=UTF-8",
                data: JSON.stringify(vUpdateUser),
                success: function (pagramRes) {
                    console.log(pagramRes)
                    handUpdatetUser();
                },
                error: function (pagram) {
                    alert(pagram.status)
                }
            })
        }
    }

    // hàm xử lý xự kiện confirm User đước ấn
    function onBtnConfirmUser() {
        $.ajax({
            url:  gBAGE_URL + gUserID,
            type: "DELETE",
            success: function (paramRes) {
                handleDeleteUserSuccess();
            },
            error: function (pagram) {
                console.log(pagram.status);
            },
        });

    }
    // hàm xử lý sự kiện khi icon edit đưọc ấn
    function onBtnEditUserClick(pagramBtnEdit) {
        gUserID = getUserIdFromButton(pagramBtnEdit);
        console.log("ID tương ứng là:" + gUserID)
        getUserById(gUserID);
        $("#update-user-modal").modal("show")

    }

    // hàm xử lý sự kiện khi icon delete đưọc ấn
    function onBtnDeleteUserClick(pagramBtnDelete) {
        gUserID = getUserIdFromButton(pagramBtnDelete);
        console.log("ID tương ứng là:" + gUserID)
        $("#delete-user-modal").modal("show")

    }
    // hàm add thêm user
    function onBtnAddUser() {
        $("#create-user-modal").modal("show");
    }

    function getAllData() {
        $.ajax({
            url: gBAGE_URL,
            type: "GET",
            dataType: "json",
            success: function (pagramUser) {
                console.log(pagramUser)
                loadDataToTable(pagramUser)
            },
            error: function (ajaxContext) {
                alert(ajaxContext.responseText)
            }

        })
    }
    function loadDataToTable(pagram) {
        var vTable = $("#user-table").DataTable();
        vTable.clear();
        vTable.rows.add(pagram);
        vTable.draw()
    }


    function getUserIdFromButton(pagramBtn) {
        var vRowTable = $(pagramBtn).closest("tr");
        var vUserRowData = gUserTable.row(vRowTable).data();
        return vUserRowData.id;
    }

    // hàm get user by ID
    function getUserById(paramUserId) {
        $.ajax({
            url: "http://203.171.20.210:8080/crud-api/users/" + paramUserId,
            type: "GET",
            success: function (paramUser) {
                showUserDataToModalUpdate(paramUser);
            },
            error: function (param) {
                console.log(param.status);
            },
        });
    }
   
    // hàm thu thập dữ liệu để create user
    function getData(paramUserObj) {
        paramUserObj.firstname = $("#input-create-firstname").val().trim();
        paramUserObj.lastname = $("#input-create-lastname").val().trim();
        paramUserObj.subject = $("#input-create-subject").val().trim();
        paramUserObj.country = $("#select-create-country").val();
        paramUserObj.customerType = $("#select-create-customer-type").val();
    }
    // hàm hiển thị  UserData ra Modal Update
    function showUserDataToModalUpdate(paramUserObj) {
        $("#input-update-firstname").val(paramUserObj.firstname);
        $("#input-update-lastname").val(paramUserObj.lastname);
        $("#input-update-subject").val(paramUserObj.subject);
        $("#select-update-country").val(paramUserObj.country);
        $("#select-update-customer-type").val(paramUserObj.customerType);
        $("#select-update-register-status").val(paramUserObj.registerStatus);

    }
    //-----------------------------------------------------
    // hàm readDataFromUpdateModal 
    function readDataFromUpdateModal(paramUserObj) {
        paramUserObj.firstname = $("#input-update-firstname").val().trim();
        paramUserObj.lastname = $("#input-update-lastname").val().trim();
        paramUserObj.subject = $("#input-update-subject").val().trim();
        paramUserObj.country = $("#select-update-country").val();
        paramUserObj.customerType = $("#select-update-customer-type").val();
        paramUserObj.customerType = $("#select-update-register-status").val();

    }

    function handUpdatetUser() {
        alert("Update User thành công")
        getAllData();
        resertModalUpdate();
        $("#update-user-modal").modal("hide");
    }
    function handleDeleteUserSuccess(){
        alert("Confirm User thành công")
        getAllData();
        $("#delete-user-modal").modal("hide");
    }
     // hàm hand inser User
     function handInsertUser() {
        alert("Thêm User thành công")
        getAllData();
        resertModalCreate();
        $("#create-user-modal").modal("hide");

    }
    // hàm resert Modal
    function resertModalCreate() {
        $("#input-create-firstname").val("");
        $("#input-create-lastname").val("");
        $("#input-create-subject").val("");
        $("#select-create-country").val("VN");
        $("#select-create-customer-type").val("Standard");

    }
    // hàm resert Modal
    function resertModalUpdate() {
        $("#input-update-firstname").val("");
        $("#input-update-lastname").val("");
        $("#input-update-subject").val("");
        $("#select-update-country").val("VN");
        $("#select-update-customer-type").val("Standard");

    }
    // hàm validate dữ liệu
    function validate(paramUserObj) {
        if (paramUserObj.firstname === "") {
            alert("Bạn chưa nhập FistName")
            return false
        }
        if (paramUserObj.lastname === "") {
            alert("Bạn chưa nhập Lastname")
            return false
        }
        if (paramUserObj.subject === "") {
            alert("Bạn chưa nhập Subject")
            return false
        }
        return true
    }
</script>
</body>

</html>